<?php

namespace ReadyApp\Exactoris\UI\View\Form\InputManager;

use ReadyApp\Exactoris\Exception\Exception;
use MapService;
use JScript;
use Application;
use SweetException;
use ReadyApp\Exactoris\Application\Query\FunctionBusinessQuery;
use JSON;
use SListBox;
use ReadyApp\Exactoris\UI\View\Form\TAsyncCallableMethods;
use ReadyApp\Exactoris\UI\View\Helper\JsHelper;
use ReadyApp\Exactoris\Application\Service\Translator;

/**
 * Class MyCustomSListBoxManager
 * Created by PhpStorm.
 *
 * @createDate       2023-05-09
 * @copyright (c)    eDokumenty Sp. z o.o.
 */
class MyCustomSListBoxManager {
    use TAsyncCallableMethods;

    protected static $cMethods = [
        'asyncSetValue',
    ];

    final public static function manage(SListBox $lookup, $params = array()) {

        $lookupName = $lookup->getName();

        $dHWND = Application::registerDialog(Application::getShortName($lookupName.'CustomAsyncTreeDialog'), 'CustomAsyncTreeDialog', './scripts/CustomAsyncTreeDialog.inc');

        $newContactIcon = new ImgFormButton(array(
            'name'      => $lookupName.'_NewContactIcon',
            'submit'    => FALSE,
            'image' => IMG_PATH.'toolbarIcons/list.png',
            'title'     => Translator::translate('Dodaj z listy'),
        ));

        $newContactIcon->script = 'App.openDialogEx(\''.$dHWND.'\', null, ({onAdd:\'App.'.$lookupName.'onAdd\'}).toJSONString())';

        $lookup->addIcon($newContactIcon);

        JScript::add('
            App.'.$lookupName.'onAdd = function(povcid) {
                $(\''.$lookupName.'v\').value = povcid;            
                asyncLibrary.execute(\'./scripts/MyCustomSListBoxManager.inc\',\'MyCustomSListBoxManager\', \'\', \'setByPKey\', ({povcid:povcid,name__:\''.$lookupName.'\'}).toJSONString(), \'if(text) {DOMO.replaceWithHTML($(\\\''.$lookupName.SListBox::INPUT_PREFIX.'\\\'), text);}\', null,FAST);
            }
        ');

    }

    /**
     * @param string $jsonString
     *
     * @return void
     * @throws SweetException
     */
    public function asyncSetValue(string $jsonString): void {
        $data = JSON::toArray($jsonString);
        $query = new FunctionBusinessQuery();

        $widgetName = $data['widgetName'] ?? NULL;
        try {
            $model = $query->getLast();
        } catch (Exception $e) {
            throw $e->getSweetException();
        }

        if ($widgetName) {
            $widget = new SListBox($widgetName);
            $widget->asyncSetValue([
                'value' => $model->getId()
            ]);
        }
    }
}